
package de.ivu.elect.presentation.veranstaltung.action;

import static java.util.Arrays.asList;

import java.util.List;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.person.entity.Personendaten;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.veranstaltung.boundary.TeilnahmeEdit;
import de.ivu.elect.business.veranstaltung.boundary.VeranstaltungConversationSelect;
import de.ivu.elect.business.veranstaltung.entity.TeilnehmerRolle;
import de.ivu.elect.business.veranstaltung.entity.Veranstaltung;
import de.ivu.elect.jee.faces.FacesMessageUtil;
import de.ivu.elect.jee.presentation.redirect.Redirect;
import de.ivu.elect.jee.presentation.view.ViewStack;
import de.ivu.elect.presentation.menu.AbstractActionEntry;
import de.ivu.elect.presentation.security.AbstractGebietSecurity;
import de.ivu.elect.presentation.veranstaltung.TeilnahmeSearchView;
import de.ivu.elect.presentation.veranstaltung.TeilnehmerEinladen;
import de.ivu.elect.presentation.veranstaltung.TeilnehmerEinladenView;

@Named(TeilnehmerEinladenAction.COMPONENT_NAME)
public class TeilnehmerEinladenAction extends AbstractActionEntry<Personendaten> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "teilnehmerEinladenAction";

  @Inject
  @ConversationGroup(TeilnehmerEinladen.class)
  private transient TeilnehmerEinladen teilnehmerEinladen;

  @Inject
  @ConversationGroup(ViewStack.class)
  private transient ViewStack viewStack;

  @Inject
  private transient VeranstaltungConversationSelect veranstaltungConversationSelect;

  @Inject
  private transient TeilnahmeEdit teilnahmeEdit;

  public TeilnehmerEinladenAction() {
    super();
  }

  @Override
  protected UseCasePermission getRequiredPermission() {
    return UseCasePermission.TEILNAHME_CREATE;
  }

  @Override
  protected AbstractGebietSecurity getGebietSecurity() {
    return getBearbeitenGebietSecurity();
  }

  @Override
  protected boolean isFireChangeEvent() {
    return false;
  }

  @Nullable
  @Override
  protected String doIt(Personendaten entity) {
    if (entity == null) {
      return null;
    }
    Veranstaltung veranstaltung = veranstaltungConversationSelect.getEntity();
    String result = erzeugeEinladungen(asList(entity), veranstaltung);
    FacesMessageUtil.addInfoMessage("teilnehmer.einladen.action.success", "teilnehmer.einladen.action.success", entity.getFamilienname(), entity.getRufname(), veranstaltung.getBezeichnung());

    return result;
  }

  @Nullable
  @Redirect
  public String einladen(TeilnehmerEinladenView teilnehmerEinladenView) {
    if (teilnehmerEinladenView == null) {
      return null;
    }

    List< ? extends Personendaten> personen = teilnehmerEinladenView.getSearchResult();
    if (personen == null || personen.isEmpty()) {
      return null;
    }
    Veranstaltung veranstaltung = veranstaltungConversationSelect.getEntity();
    String result = erzeugeEinladungen(personen, veranstaltung);
    FacesMessageUtil.addInfoMessage("teilnehmer.einladen.action.personen.success", "teilnehmer.einladen.action.personen.success", personen.size(), veranstaltung.getBezeichnung());
    return result;
  }

  private String erzeugeEinladungen(List< ? extends Personendaten> personendatens, Veranstaltung veranstaltung) {
    teilnahmeEdit.teilnehmerHinzufuegen(veranstaltung, personendatens, TeilnehmerRolle.TEILNEHMER);
    viewStack.back(); // vom aktuellen View weg
    return TeilnahmeSearchView.VIEW_ID; // und wieder zur Übersicht aller Teilnhemer
  }

  @Override
  protected void fireChangeEvent() {
  }

  @Override
  public boolean isDisabledInternal(@Nonnull Personendaten entity) {
    return entity == null || !teilnehmerEinladen.isTeilnehmerEinladenModus();
  }

  @Override
  public String getLabelKey() {
    return "teilnehmer.einladen.action";
  }

  @Override
  public String getIcon() {
    return appIcons.getIconCircleSmallPlus();
  }

  @Override
  protected String getSimpleClassName() {
    return TeilnehmerEinladenAction.class.getSimpleName();
  }
}
